{=======================================================================================================================

   " ".

       .

========================================================================================================================

  :

  08.03.2015 [+]   .
             [*]  .
             [-] .
             [*]   ""  "".
             [+] taList: TADODataSet.
  05.03.2015 [*]     .
  03.03.2015 [+]   .
  26.02.2015 [+]    .
  23.02.2015 [+] btRefresh.
             [+] btDelete.
             [+] btEdit.
  22.02.2015 [-] TPropStorageEh.
             [+] btInsert.
             [*]  DBNavigator  .
  19.02.2015 [*] .
  08.03.2012 [-]     .
             [*]   .
  22.02.2012 [+]   .
  24.02.2012 [*] .
  12.02.2012 [*] .
  09.02.2012 [!]    Delphi XE2.
  31.03.2011 [*]     .
  30.03.2011 [*]   96 PixelsPerInch.
  02.07.2007 [-]  uses    RXLib.
  10.11.2006 [*]   XP.
  25.06.2002 [+]   CreateParams.
  19.11.2001 [+]   .
  16.11.2001 [+]  .
             [*]  .
             [*]    .
             [-]  TAB.
  01.01.1999 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgBaseList.pas,v 1.2 2015/03/08 09:03:46 tsk Exp $
=======================================================================================================================}
unit dgBaseList;

interface

uses  Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, Buttons, ExtCtrls, Grids, DBGrids, DBCtrls, Db,
      DBGridEh, GridsEh, DBGridEhGrouping, ToolCtrlsEh, DBGridEhToolCtrls, DBAxisGridsEh, DynVarsEh, Data.Win.ADODB,
      // Comming:
      CommingADO;

type
  TBASEListDG = class( TForm )
    grList: TDBGridEh;
    dsList: TDataSource;
    btExit: TBitBtn;
    btBack: TBitBtn;
    btInsert: TBitBtn;
    btEdit: TBitBtn;
    btDelete: TSpeedButton;
    btFind: TSpeedButton;
    taList: TADODataSet;
    procedure FormCreate(Sender: TObject);
    procedure dsListStateChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private    { Private declarations }
    FField: TField;
    FVisual: Boolean;
    procedure   SetField( const Value: TField );
    procedure SetVisual(const Value: Boolean);
  public    { Public declarations }
    property    Field: TField read FField write SetField;
    property    Visual: Boolean read FVisual write SetVisual;
    procedure   SetBackValue( Value: Variant );
  end;

implementation

uses dmCommingData;

{$R *.DFM}
//======================================================================================================================
{ TBASEListDG }
//======================================================================================================================
procedure TBASEListDG.FormCreate(Sender: TObject);
begin
  FField := nil;
end;
//======================================================================================================================
procedure TBASEListDG.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Tag := StrToIntDef( dsList.DataSet.Fields[0].AsString, 0);
end;
//======================================================================================================================
procedure TBASEListDG.dsListStateChange(Sender: TObject);
begin
  btInsert.Enabled  := ( dsList.DataSet.Active );
  btEdit.Enabled    := ( dsList.DataSet.Active and ( dsList.DataSet.RecordCount > 0 ));
  btDelete.Enabled  := ( dsList.DataSet.Active and ( dsList.DataSet.RecordCount > 0 ));
end;
//======================================================================================================================
procedure TBASEListDG.SetField( const Value: TField );
begin
  if FField <> Value then begin
    FField := Value;
    btBack.Enabled := ( FField <> nil ) and Assigned( Self.btBack.OnClick );
  end;
end;
//======================================================================================================================
procedure TBASEListDG.SetVisual(const Value: Boolean);
begin
  if FVisual <> Value then begin
    if FVisual
      then dsList.DataSet.EnableControls
      else dsList.DataSet.DisableControls;
  end;
end;
//======================================================================================================================
procedure TBASEListDG.SetBackValue( Value: Variant );
begin
  if not ( Field.DataSet.State in [ dsEdit, dsInsert ] ) then Field.DataSet.Edit;
  Field.Value := Value;
end;
//======================================================================================================================
end.
