/*=====================================================================================================================

   " ".

    .

=======================================================================================================================

  :

  03.03.2015 [+] GridKind:  .
  23.02.2015 [*] LookKind:  .
  12.03.2012 [*] LookKind: .
  09.03.2012 [+] SortKind, MoveKind:    .
  03.04.2007 [+]  .
  09.10.1997 [!]  .

=======================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scKind.sql,v 1.1 2015/03/08 05:02:37 tsk Exp $
=====================================================================================================================*/
USE ComputerWare
--
EXECUTE CheckDropProcedure 'GridKind'
EXECUTE CheckDropProcedure 'LookKind'
EXECUTE CheckDropProcedure 'SortKind'
EXECUTE CheckDropProcedure 'MoveKind'
--
GO
--=====================================================================================================================
CREATE PROCEDURE GridKind @TP CHAR(1) = 'H'
AS
  SELECT IdKind AS ID, 
         ShortName,
         KindName,
         KindType,
         UsesModel,
         UsesDevice
    FROM Kind
    WHERE (KindType = @TP)
    ORDER BY KindOrder
--
GO
--=====================================================================================================================
CREATE PROCEDURE LookKind @TP CHAR(1) = 'H'
AS
  SELECT IdKind AS ID, 
         ISNULL(ShortName + ': ', '') + KindName AS Name,
         KindType
    FROM Kind
    WHERE (KindType = @TP)
    ORDER BY KindOrder
--
GO
--=====================================================================================================================
CREATE PROCEDURE SortKind @KD INT
AS
  DECLARE @SM CHAR(1), @SR INT, @NL INT
  SELECT  @SM = KindType FROM Kind WHERE (IdKind = @KD)
  DECLARE Sort CURSOR FOR SELECT KindOrder FROM Kind WHERE (KindType = @SM) ORDER BY KindOrder
  SET @SR = 1
  OPEN Sort
  FETCH NEXT FROM Sort INTO @NL
  WHILE @@FETCH_STATUS = 0 BEGIN
    UPDATE Kind SET KindOrder = @SR WHERE CURRENT OF Sort
    SET @SR = @SR + 2
    FETCH NEXT FROM Sort INTO @NL
  END
  CLOSE Sort
  DEALLOCATE Sort
--
GO
--=====================================================================================================================
CREATE PROCEDURE MoveKind @KD INT, @DR INT
AS
  -- @DR: -1 - , +1 - 
  SET @DR = @DR * 3
  UPDATE Kind SET KindOrder += @DR WHERE (IdKind = @KD)
  EXECUTE SortKind @KD
--
GO
--=====================================================================================================================
-- 
--
EXECUTE GridKind
--EXECUTE LookKind 'H'
--EXECUTE MoveKind 156, -1
