/*=====================================================================================================================

   " ".

    , . .

=======================================================================================================================

  :

  07.06.2013 [+] ReportDeviceDetail:  .
             [+] ReportDeviceTitle:  .
             [+]  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972013 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scDeviceReport.sql,v 1.1 2013/06/07 13:41:26 tsk Exp $
=====================================================================================================================*/
USE ComputerWare
--
EXECUTE CheckDropProcedure 'ReportDeviceTitle'
EXECUTE CheckDropProcedure 'ReportDeviceDetail'
--
GO
--=====================================================================================================================
CREATE PROCEDURE ReportDeviceTitle @DV INT
AS
  DECLARE @NM VARCHAR(500), @WP VARCHAR(500), @DN VARCHAR(1000), @DP INT
  SELECT @NM = ViewDevicePowerName.NameNumber + ' (' + ViewWorkplacePowerName.NameUser + ')', @DP = Workplace.WrkpIdDepartment 
    FROM DeviceUnit 
      INNER JOIN ViewDevicePowerName ON DeviceUnit.IdDevice = ViewDevicePowerName.ID
      INNER JOIN Workplace ON DeviceUnit.DevcIdWorkplace = Workplace.IdWorkplace
      INNER JOIN ViewWorkplacePowerName ON Workplace.IdWorkplace = ViewWorkplacePowerName.ID
    WHERE (DeviceUnit.IdDevice = @DV) 
  --
  SELECT @DP = DprtIdHigher, @DN = DprtName FROM Department WHERE (IdDepartment = @DP)
  WHILE @DP <> 0 
    SELECT @DP = DprtIdHigher, @DN = @DN  + '/' + DprtName FROM Department WHERE (IdDepartment = @DP)
--
  SELECT  @NM AS Name, @DN AS Department
--
GO
--=====================================================================================================================
CREATE PROCEDURE ReportDeviceDetail @DV INT
AS
  SELECT Kind.KindName, 
--         Model.ModlName + ISNULL(': ' + Model.ModlParametersValue, '') + ISNULL(' (' + Model.ModlNote + ')', '') AS ModName,
         Model.[DisplayNameFull],  
         CompleteSet.DisplayNumber, 
         ViewDocumentPowerName.NameFirm AS DocName
    FROM CompleteSet 
      INNER JOIN Model ON CompleteSet.CmplIdModel = Model.IdModel 
      INNER JOIN Kind ON Model.ModlKind = Kind.IdKind 
      LEFT OUTER JOIN ViewDocumentPowerName ON CompleteSet.DocumentId = ViewDocumentPowerName.ID
    WHERE (CompleteSet.CmplIdDevice = @DV)
    ORDER BY Kind.KindOrder
--
GO
--=====================================================================================================================
-- 
-- 1140 =  ,  U1140
--
EXECUTE ReportDeviceTitle 1140
EXECUTE ReportDeviceDetail 1140

