/*=====================================================================================================================

   " ".

     .

=======================================================================================================================

  :

  21.03.2012 [-] CompleteSetMoving:   DisplaceHard   scElementMove.sql.
             [*] CompleteSetMoving:  .
  17.06.2008 [+] DisplacementPeriod:     .
  16.06.2008 [+] CulcPeriodLaser:      .
             [+] CompleteSetMoving:   .
             [+]  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scMove.sql,v 1.5 2012/03/24 04:09:49 tsk Exp $
=====================================================================================================================*/
USE ComputerWare
--
EXECUTE CheckDropTrigger    'DisplacementPeriod'
EXECUTE CheckDropProcedure  'CulcPeriodLaser'
--
GO
--=====================================================================================================================
CREATE PROCEDURE CulcPeriodLaser @DV INT
AS
  IF EXISTS ( SELECT * FROM CompleteSet INNER JOIN Model ON CompleteSet.CmplIdModel = Model.IdModel
                WHERE (Model.ModlKind = 12) AND (CompleteSet.CmplIdDevice = @DV))
    BEGIN
      DECLARE @P INT, @DL DATETIME, @DT DATETIME, @DN DATETIME, @PS INT, @PC INT, @V INT
      SET @P = 30         -- 30  -
      SET @PS = 0         --  
      SET @PC = 0         --  
      SET @V = 5          -- 
      DECLARE Period CURSOR FOR
      SELECT TOP (6) Displacement.Moving
        FROM Displacement 
          INNER JOIN CompleteSet ON Displacement.Component = CompleteSet.IdComponent 
          INNER JOIN Model ON CompleteSet.CmplIdModel = Model.IdModel
        WHERE (Displacement.DeviceID = @DV) AND (Model.ModlKind = 40)
        ORDER BY Displacement.Moving DESC      
      OPEN Period
      FETCH NEXT FROM Period INTO @DT
      SET @DL = @DT
      WHILE @@FETCH_STATUS = 0 BEGIN
        SET @DN = @DT
        FETCH NEXT FROM Period INTO @DT
        SET @PS = @PS + ( DATEDIFF( day, @DT, @DN ) * @V )
        SET @PC = @PC + @V
        SET @V  = @V - 1
      END
      CLOSE Period
      DEALLOCATE Period
      IF ( NOT @DL IS NULL) BEGIN
        SET @P = DATEDIFF( day, @DL, GETDATE() )
        IF ( @PS > 0 ) SET @P = @PS / @PC
      END ELSE BEGIN
        SET @DL = GETDATE() --  -
      END
      UPDATE DeviceUnit
        SET DateLast = @DL, DateNext = DATEADD( day, @P, @DL )
        WHERE IdDevice = @DV
    END
--
GO
--=====================================================================================================================
--CREATE TRIGGER CompleteSetMoving ON CompleteSet FOR INSERT, UPDATE
--AS
--  IF UPDATE ( CmplIdDevice ) BEGIN
--    DECLARE @Set INT
--    DECLARE @Device INT
--    DECLARE @DeviceName VARCHAR(50)	
--    DECLARE @PlaceName VARCHAR(50)
--    DECLARE @DprtName VARCHAR(50)

--    SELECT @Set = IdComponent, @Device = CmplIdDevice FROM Inserted
--    SELECT @DeviceName = case when ( KindName = '*')
--                           then DeviceUnit.DisplayDevice
--                           else KindName + ' ' +DeviceUnit.DisplayDevice
--                         end + ' (' + Workplace.WrkpName + ')',
--           @PlaceName = Workplace.WrkpName, 
--           @DprtName = Department.DprtName
--      FROM DeviceUnit 
--        INNER JOIN Kind ON DeviceUnit.DevcIdKind = Kind.IdKind
--        INNER JOIN Workplace ON DeviceUnit.DevcIdWorkplace = Workplace.IdWorkplace 
--        INNER JOIN Department ON Workplace.WrkpIdDepartment = Department.IdDepartment
--       WHERE (DeviceUnit.IdDevice = @Device)

--    INSERT INTO Displacement (Component, Moving, DeviceID, Device, Workplace, Department)
--                        VALUES (@Set, GETDATE(), @Device, @DeviceName, @PlaceName, @DprtName )
--    EXECUTE CulcPeriodLaser @Device
--  END 
----
--GO
--=====================================================================================================================
--    
--CREATE TRIGGER DisplacementPeriod ON Displacement FOR INSERT, UPDATE
--AS
--  DECLARE @DV INT
--  SELECT @DV = CompleteSet.CmplIdDevice
--    FROM Inserted INNER JOIN CompleteSet ON Inserted.Component = CompleteSet.IdComponent  
--  EXECUTE CulcPeriodLaser @DV
----
--GO
--=====================================================================================================================
-- 
-- EXECUTE CulcPeriodLaser 790
