/*=====================================================================================================================

   " ".

      ,  .

=======================================================================================================================

  :

  21.02.2015 [*] ExecFavorite:   .
  21.03.2012 [-] LoadTree:  .
             [*] LoadNodeDevice:  ViewDevicePowerName.
  20.03.2012 [+] MoveTree:   .
             [+] SortTree:   .
             [+] LoadTreeSorting:       .
             [*] LoadNodeWorkPlace:  ViewWorkplacePowerName.
             [*]  .
  29.02.2012 [*] GridFavorite:    .
  26.02.2012 [+] DeleteDepartment, DeleteWorkPlace, DeleteDeviceUnit, DeleteDisplacement: .
             [+] LoadNodeDepartm, LoadNodeWorkPlace, LoadNodeDevice: .
             [+] LoadTree:   .
             [*]  .
  24.02.2012 [*] .
  11.02.2012 [+] ExecFavorite:    (, , ).
  10.02.2012 [+] GridFavorite:   .
  26.07.2007 [+] LookupDevice:   .
  14.12.2006 [+]  .
  09.10.1997 [!]  .

=======================================================================================================================
  Copyright 19972012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scTree.sql,v 1.9 2015/02/22 16:02:19 tsk Exp $
=====================================================================================================================*/
USE ComputerWare
--
EXECUTE CheckDropProcedure  'LoadTree'
EXECUTE CheckDropProcedure  'LoadNodeDepartm'
EXECUTE CheckDropProcedure  'LoadNodeWorkPlace'
EXECUTE CheckDropProcedure  'LoadNodeDevice'
EXECUTE CheckDropProcedure  'DeleteDepartment'
EXECUTE CheckDropProcedure  'DeleteWorkPlace'
EXECUTE CheckDropProcedure  'DeleteDeviceUnit'
EXECUTE CheckDropProcedure  'DeleteDisplacement'
EXECUTE CheckDropProcedure  'GridFavorite'
EXECUTE CheckDropProcedure  'ExecFavorite'
EXECUTE CheckDropView		    'LookupDevice'
EXECUTE CheckDropView		    'LoadTreeSorting'
EXECUTE CheckDropProcedure  'SortTree'
EXECUTE CheckDropProcedure  'MoveTree'
--
GO
--=====================================================================================================================
CREATE PROCEDURE LoadNodeDepartm @HID INT, @HTM VARCHAR(100)
AS
  IF ( SELECT COUNT(*) FROM Department WHERE DprtIdHigher = @HID ) > 0
    INSERT INTO #MenuLoad SELECT @HTM + '_' + STR(DprtOrder,3), DprtName,
        IdDepartment, @HTM, DprtIdHigher, 'D', 35 FROM Department WHERE DprtIdHigher = @HID
GO
--=====================================================================================================================
CREATE PROCEDURE LoadNodeWorkPlace @HID INT, @HTM VARCHAR(100)
AS
  IF ( SELECT COUNT(*) FROM Workplace WHERE WrkpIdDepartment = @HID ) > 0
    INSERT INTO #MenuLoad SELECT @HTM + '_' + STR([Order], 3), 
                                 NameUser,
                                 ID, 
                                 @HTM, 
                                 Higher, 
                                 'W', 
                                 36
                            FROM ViewWorkplacePowerName WHERE Higher = @HID
--
GO
--=====================================================================================================================
CREATE PROCEDURE LoadNodeDevice @HID INT, @HTM VARCHAR(100)
AS
  IF ( SELECT COUNT(*) FROM DeviceUnit WHERE DevcIdWorkplace = @HID ) > 0
    INSERT INTO #MenuLoad SELECT @HTM + '_' + STR(Sorting,3), 
                                 NameNumber,
                                 ID, 
                                 @HTM, 
                                 High, 
                                 'V', 
                                 37
                            FROM ViewDevicePowerName
                            WHERE High = @HID
--
GO
--=====================================================================================================================
CREATE PROCEDURE LoadTree
AS
  SELECT CAST( '1'  AS VARCHAR(100)) AS Item,
         CAST( '?'  AS VARCHAR(100)) AS Caption,
         0          AS ID,
         CAST( ''   AS VARCHAR(100)) AS BossItem,
         0          AS Higher,
         'D'        AS Kind,
         35         AS ImageType
         INTO #MenuLoad
  DELETE FROM #MenuLoad

  IF ( SELECT COUNT(*) FROM Department WHERE DprtIdHigher = 0 ) > 0
    INSERT INTO #MenuLoad SELECT '1_' + STR(DprtOrder,3), DprtName, IdDepartment, '1', DprtIdHigher, 'D', 35
                            FROM Department WHERE DprtIdHigher = 0
--
  DECLARE NodeItemDP CURSOR FOR SELECT ID, Item FROM #MenuLoad WHERE ID > 0 AND Kind = 'D'
  DECLARE @HID INT, @HTM VARCHAR(100)
  OPEN NodeItemDP
  FETCH NEXT FROM NodeItemDP INTO @HID, @HTM
  WHILE @@FETCH_STATUS = 0 BEGIN
    EXEC LoadNodeDepartm @HID, @HTM
    FETCH NEXT FROM NodeItemDP INTO @HID, @HTM
  END
  CLOSE NodeItemDP
  DEALLOCATE NodeItemDP

  DECLARE NodeItemWP CURSOR FOR SELECT ID, Item FROM #MenuLoad WHERE ID > 0 AND Kind = 'D'
  OPEN NodeItemWP
  FETCH NEXT FROM NodeItemWP INTO @HID, @HTM
  WHILE @@FETCH_STATUS = 0 BEGIN
    EXEC LoadNodeWorkPlace @HID, @HTM
    FETCH NEXT FROM NodeItemWP INTO @HID, @HTM
  END
  CLOSE NodeItemWP
  DEALLOCATE NodeItemWP

  DECLARE NodeItemDU CURSOR FOR SELECT ID, Item FROM #MenuLoad WHERE ID > 0 AND Kind = 'W'
  OPEN NodeItemDU
  FETCH NEXT FROM NodeItemDU INTO @HID, @HTM
  WHILE @@FETCH_STATUS = 0 BEGIN
    EXEC LoadNodeDevice @HID, @HTM
    FETCH NEXT FROM NodeItemDU INTO @HID, @HTM
  END
  CLOSE NodeItemDU
  DEALLOCATE NodeItemDU
--
  SELECT * FROM #MenuLoad ORDER BY 1, 6 DESC
--
GO
--=====================================================================================================================
CREATE PROCEDURE GridFavorite
AS
  SELECT ID, KeyObject, Name
    FROM Favorite
    WHERE ISNULL([User], SUSER_NAME()) = SUSER_NAME ()
    ORDER BY LastCall DESC
--
GO
--=====================================================================================================================
CREATE PROCEDURE ExecFavorite @R INT, @KY VARCHAR(50) = '0', @NM VARCHAR(100) = ''
AS
  -- .
  IF @R = 1 
    IF NOT EXISTS (SELECT KeyObject FROM Favorite WHERE (KeyObject=@KY) AND ([User]=SUSER_NAME()))
      INSERT INTO Favorite (KeyObject, Name) VALUES ( @KY, @NM ) 
  -- 
  IF @R = 2 UPDATE Favorite SET LastCall = GETDATE() WHERE (KeyObject = @KY )
  -- 
  IF @R = 3 DELETE Favorite WHERE (KeyObject = @KY )
--
GO
--=====================================================================================================================
CREATE PROCEDURE DeleteDepartment @Departm INT AS
  DELETE FROM Department WHERE (IDDepartment = @Departm)
GO
CREATE PROCEDURE DeleteWorkPlace @WorkPlac INT AS
  DELETE FROM WorkPlace WHERE (IdWorkPlace = @WorkPlac)
GO
CREATE PROCEDURE DeleteDeviceUnit @Device INT AS
  DELETE FROM DeviceUnit WHERE (IdDevice = @Device)
GO
CREATE PROCEDURE DeleteDisplacement @ID INT AS
  DELETE FROM Displacement WHERE (ID = @ID)
GO
--=====================================================================================================================
CREATE VIEW LookupDevice
AS
	SELECT DeviceUnit.IdDevice AS ID, 
	       Department.DprtName AS Department, 
         Workplace.WrkpName AS Place, 
         DeviceUnit.DevcName AS Device
    FROM DeviceUnit 
      INNER JOIN Workplace ON DeviceUnit.DevcIdWorkplace = Workplace.IdWorkplace 
      INNER JOIN Department ON Workplace.WrkpIdDepartment = Department.IdDepartment
--
GO
--=====================================================================================================================
CREATE VIEW LoadTreeSorting
AS
  SELECT DprtIdHigher AS High, 
         'D'          AS Node, 
         IdDepartment AS ID, 
         DprtOrder    AS Sorting
    FROM Department
  --
  UNION
  --
  SELECT  WrkpIdDepartment, 
          'W', 
          IdWorkplace, 
          WrkpOrder
    FROM Workplace
--
GO
--=====================================================================================================================
CREATE PROCEDURE SortTree @HI INT
AS
  DECLARE @SR INT, @ND CHAR(1), @ID INT
  DECLARE Sort CURSOR FOR SELECT Node, ID FROM LoadTreeSorting WHERE (High = @HI) ORDER BY Sorting
  SET @SR = 1
  OPEN Sort
  FETCH NEXT FROM Sort INTO @ND, @ID
  WHILE @@FETCH_STATUS = 0 BEGIN
    IF ( @ND = 'D' ) UPDATE Department SET DprtOrder = @SR WHERE IdDepartment = @ID
    IF ( @ND = 'W' ) UPDATE Workplace  SET WrkpOrder = @SR WHERE IdWorkplace = @ID
    SET @SR = @SR + 2
    FETCH NEXT FROM Sort INTO @ND, @ID
  END
  CLOSE Sort
  DEALLOCATE Sort
--
GO
--=====================================================================================================================
CREATE PROCEDURE MoveTree @KD CHAR(1), @ID INT, @DR INT
AS
  DECLARE @HI INT
  -- @DR: -1 - , +1 - 
  SET @DR = @DR * 3
  IF ( @KD = 'D' ) BEGIN
    UPDATE Department SET DprtOrder += @DR WHERE IdDepartment = @ID
    SELECT @HI = DprtIdHigher FROM Department WHERE IdDepartment = @ID
  END
  IF ( @KD = 'W' ) BEGIN
    UPDATE Workplace SET WrkpOrder += @DR WHERE IdWorkplace = @ID
    SELECT @HI = WrkpIdDepartment FROM Workplace WHERE IdWorkplace = @ID
  END
  EXECUTE SortTree @HI
--
GO
--=====================================================================================================================
-- 
--SELECT * FROM LookupDevice
--SELECT * FROM LoadTreeSorting WHERE (High = 127)ORDER BY High, Sorting
--EXECUTE ExecFavorite 1
--EXECUTE GridFavorite
--EXECUTE SortTree 127
--EXECUTE MoveTree 'D', 86, 1
EXECUTE LoadTree