/*=====================================================================================================================

   " ".

    .

=======================================================================================================================

  :

  04.05.2015 [+] GridDomainUser:     SKYPE.
  04.03.2015 [*] GridNodeList:    .
  23.07.2014 [*] CheckDomainUser:   .
  20.03.2012 [*] CheckDomainUser:     .
  17.03.2012 [*] IgnoreDomainUser:    .
  15.03.2012 [+] IgnoreDomainUser:       .
             [+] CheckDomainUser:    .
             [+] GridDomainUser:    .
  07.08.2009 [+] DeleteUseComputer:   .
             [+] GridNodeUserList:  .
  03.08.2009 [-] ExcelNodeList:    .
  23.07.2009 [+] ExcelNodeList:      .
  16.07.2009 [+]  .
  09.10.1997 [!]  .

=======================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scNet.sql,v 1.9 2015/05/04 06:32:24 tsk Exp $
=====================================================================================================================*/
USE ComputerWare
--
EXECUTE CheckDropProcedure 'GridNodeList'
--
EXECUTE CheckDropProcedure 'GridNodeUserList'
EXECUTE CheckDropProcedure 'DeleteUseComputer'
EXECUTE CheckDropProcedure 'GridDomainUser'
EXECUTE CheckDropProcedure 'CheckDomainUser'
EXECUTE CheckDropProcedure 'IgnoreDomainUser'
--
GO
--=====================================================================================================================
--    .
--=====================================================================================================================
CREATE PROCEDURE GridNodeList
AS
  SELECT DeviceUnit.IdDevice    AS ID, 
         DeviceUnit.Domain      AS Domain, 
         Workplace.WrkpName     AS Workplace, 
         Workplace.Phone        AS Phone,
         Workplace.IdWorkplace  AS IDWorkplae
    FROM DeviceUnit 
      INNER JOIN Workplace ON DeviceUnit.DevcIdWorkplace = Workplace.IdWorkplace
    WHERE (NOT (DeviceUnit.Domain IS NULL))
    ORDER BY DeviceUnit.Domain
--
GO
--=====================================================================================================================
CREATE PROCEDURE GridNodeUserList @ND INT
AS
  SELECT UseComputer.ID, 
         [User].Login, 
         [User].Name, 
         [User].Pass
    FROM UseComputer 
      INNER JOIN [User] ON UseComputer.[User] = [User].ID
    WHERE (UseComputer.Computer = @ND)
    ORDER BY [User].Login
--
GO
--=====================================================================================================================
CREATE PROCEDURE DeleteUseComputer @ID INT
AS
  DELETE UseComputer WHERE ID = @ID
--
GO
--=====================================================================================================================
-- 
--=====================================================================================================================
CREATE PROCEDURE GridDomainUser
AS
  SELECT [User].ID, 
         [User].Login, [User].Domain, 
         [User].Name + ISNULL(' ' + [User].AddName, '') AS Name,
         Pass, AddName, 
         EMail, MailPass, EMailGroup,
         SkypeLogin, SkypePass,
         Workplace.WrkpName AS Workplace, Workplace.Phone, Workplace.IdWorkplace AS WorkplaceID
    FROM [User] 
      LEFT OUTER JOIN Workplace ON [User].ID = Workplace.[User]
      ORDER BY [User].Login
--
GO
--=====================================================================================================================
CREATE PROCEDURE CheckDomainUser @DM VARCHAR(20), @US VARCHAR(50), @UN VARCHAR(100), @RS VARCHAR(200) OUTPUT
AS
  SET @RS = CONVERT( VARCHAR, GETDATE(), 108 ) + ' > '
  DECLARE @ID INT, @OD VARCHAR(20), @ON VARCHAR(100), @IG VARCHAR(50)
  SET @IG = @DM + '\' + @US
  IF EXISTS (SELECT DomainUser FROM UserIgnore WHERE (DomainUser = @IG)) BEGIN
    SET @RS = @RS + ' ' + @IG
    RETURN 0
  END
  SELECT @ID = ID, @OD = Domain, @ON = Name FROM [User] WHERE ([Login] = @US) AND ((Domain = @DM ) OR (Domain IS NULL))
  --  :
  IF (NOT @ID IS NULL) BEGIN
    --  
    IF ( @OD IS NULL ) BEGIN
      UPDATE [User] SET Domain = @DM WHERE ID = @ID
      SET @RS = @RS + @US + ' >  : ' + @DM
    END ELSE IF ( @ON <> @UN ) BEGIN
        UPDATE [User] SET Name = @UN, AddName = @ON WHERE ID = @ID
        SET @RS = @RS + @IG + ' >   ( ): ' + @UN
      END ELSE BEGIN
        SET @RS = @RS + ' ' + @IG + ': ' + @UN
      END
  --  :
  END ELSE BEGIN
    INSERT [User] ( Domain, DomainSource, [Login], Name ) VALUES ( @DM, 1, @US, @UN )
    SET @RS = @RS + '  ' + @IG + ': ' + @UN
  END
--
GO
--=====================================================================================================================
CREATE PROCEDURE IgnoreDomainUser @ID INT
AS
  INSERT INTO UserIgnore (DomainUser) SELECT ISNULL(Domain + '\', '') + [Login] FROM [User] WHERE (ID = @ID)
  DELETE [User] WHERE (ID = @ID)
--
GO
--=====================================================================================================================
-- 
-- 931 - omts.filit.ru
--
--EXECUTE GridNodeList
--EXECUTE GridNodeUserList 931
--EXECUTE DeleteUseComputer 72
EXECUTE GridDomainUser

--DECLARE @RS VARCHAR(200)
--EXECUTE CheckDomainUser 'FILIT', 'tsk', ' ', @RS OUTPUT
--SELECT @RS
